/////////////////////////////////////////////////////////////////////////////
// Name:        ax_view_summary.h
// Purpose:     Summary view
// Author:      Julian Smart
// Modified by:
// Created:     2009-03-20
// RCS-ID:
// Copyright:   (c) Julian Smart
// Licence:     New BSD License
/////////////////////////////////////////////////////////////////////////////

#ifndef _AX_VIEW_SUMMARY_H_
#define _AX_VIEW_SUMMARY_H_

/*
 * Includes
 */

#include "ax/ax_view.h"

/*
 * Forward declarations
 */

class AxSummaryViewPanel;

/**
    @class AxSummaryView
    
    Handles UI for the summary view.

    @category{ax}
 */

class AxSummaryView: public AxView
{
    DECLARE_DYNAMIC_CLASS( AxSummaryView )

public:
// Constructors

    AxSummaryView() { Init(); }
    ~AxSummaryView() {}

// Operations

    void Init();

    virtual bool Activate(AxViewManager* viewManager, AxDocument* doc);
    virtual bool Deactivate(AxViewManager* viewManager);

    virtual bool Initialize(AxViewManager* viewManager);
    virtual bool Uninitialize(AxViewManager* viewManager);
    
    AxSummaryViewPanel* GetSummaryViewPanel() const;

    void SetDescription(const wxString& text);

protected:

};

#endif
    // _AX_VIEW_SUMMARY_H_
