/////////////////////////////////////////////////////////////////////////////
// Name:        tts_speechsettingsdialog.h
// Purpose:     
// Author:      Julian Smart
// Modified by: 
// Created:     20/02/2009 15:36:36
// RCS-ID:      
// Copyright:   (c) Anthemion Software Limited
// Licence:     New BSD License
/////////////////////////////////////////////////////////////////////////////

#ifndef _TTS_SPEECHSETTINGSDIALOG_H_
#define _TTS_SPEECHSETTINGSDIALOG_H_

/*
 * Includes
 */

////@begin includes
////@end includes

#include "tts/tts_speechsettingspanel.h"

/*
 * Forward declarations
 */

////@begin forward declarations
class wxTTSSpeechSettingsPanel;
////@end forward declarations

/*
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_WXTTSSPEECHSETTINGSDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_WXTTSSPEECHSETTINGSDIALOG_TITLE _("Speech Settings")
#define SYMBOL_WXTTSSPEECHSETTINGSDIALOG_IDNAME wxID_ANY
#define SYMBOL_WXTTSSPEECHSETTINGSDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_WXTTSSPEECHSETTINGSDIALOG_POSITION wxDefaultPosition
////@end control identifiers

/**
    @class wxTTSSpeechSettingsDialog
    
    @category{tts}
 */

class wxTTSSpeechSettingsDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( wxTTSSpeechSettingsDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    wxTTSSpeechSettingsDialog();
    wxTTSSpeechSettingsDialog( const wxTTSSpeechSettingsInfo& info, wxWindow* parent, wxWindowID id = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_IDNAME, const wxString& caption = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_TITLE, const wxPoint& pos = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_POSITION, const wxSize& size = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_SIZE, long style = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_STYLE );

    /// Creation
    bool Create( const wxTTSSpeechSettingsInfo& info, wxWindow* parent, wxWindowID id = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_IDNAME, const wxString& caption = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_TITLE, const wxPoint& pos = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_POSITION, const wxSize& size = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_SIZE, long style = SYMBOL_WXTTSSPEECHSETTINGSDIALOG_STYLE );

    /// Destructor
    ~wxTTSSpeechSettingsDialog();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    /// Set info
    void SetInfo(const wxTTSSpeechSettingsInfo& info) { m_speechSettingsPanel->SetInfo(info); }

    /// Get info
    const wxTTSSpeechSettingsInfo& GetInfo() const { return m_speechSettingsPanel->GetInfo(); }

////@begin wxTTSSpeechSettingsDialog event handler declarations

////@end wxTTSSpeechSettingsDialog event handler declarations

////@begin wxTTSSpeechSettingsDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end wxTTSSpeechSettingsDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin wxTTSSpeechSettingsDialog member variables
    wxStaticText* m_captionCtrl;
    wxStaticText* m_descriptionCtrl;
    wxTTSSpeechSettingsPanel* m_speechSettingsPanel;
////@end wxTTSSpeechSettingsDialog member variables
};

#endif
    // _TTS_SPEECHSETTINGSDIALOG_H_
